#include "config.h"
#include "core/dom/ObjectFocusTextMap.h"

namespace blink {
    
using namespace std;

ObjectFocusTextMap::ObjectFocusTextMap() {
  m_map["text"] = "Input form. Please enter text.";
  m_map["password"] = "Input form. Please enter password.";
  m_map["search"] = "Input form. Please enter search text.";
  m_map["tel"] = "Input form. Please enter phone number.";
  m_map["url"] = "Input form. Please enter URL.";
  m_map["email"] = "Input form. Please enter email address.";
  m_map["datetime"] = "Input form. Please enter time.";
  m_map["submit"] = "Submit button.";
  m_map["file"] = "File button.";
  m_map["reset"] = "Reset button.";
  m_map["button"] = "Button.";
  m_map["image"] = "Image.";
  m_map["image2"] = "Link of image.";
  m_map["date"] = "Picker of date. Please set date.";
  m_map["time"] = "Picker of time. Please set time.";
  m_map["datetime-local"] = "Picker of time. Please select local time.";
  m_map["month"] = "Picker of month. Please select month.";
  m_map["week"] = "Picker of week. Please select week.";
  m_map["number"] = "Input form. Please enter number.";
  m_map["range"] = "Range input.";
  m_map["color"] = "Picker of colour. Please select colour.";
  m_map["radio"] = "Radio button.";
  m_map["checkbox"] = "Checkbox.";
  m_map["link-start"] = "Start of link.";
  m_map["link-end"] = "End of link.";
  m_map["link-tag-start"] = "";
  m_map["link-tag-end"] = "";
  m_map["checked"] = "Checked.";
  m_map["unchecked"] = "Unchecked.";
  m_map["comma"] = ",";
}

string ObjectFocusTextMap::findObjectTextMap(string key) {
  string text;   
  if (m_map.count(key) > 0) {
    std::map<string, string>::iterator itr = m_map.find(key);
    text = itr->second;
  }
  return text;
}

void ObjectFocusTextMap::setFocusedTextList(vector<string> texts) {
  for (unsigned int i=0; i < texts.size(); ++i) {
    vector<string> result;
    splitFocusedText(texts[i], result);
    if (result.size() == 2) {
      m_map.erase(result[0]);
      m_map.insert(make_pair(result[0], result[1]));
    }
  }
}

void ObjectFocusTextMap::splitFocusedText(string text, vector<string>& result) {
  string::size_type pos = text.find("=");
  if(pos == string::npos) {
    result.push_back(text.substr(0));
    return;
  }
  result.push_back(text.substr(0, pos));
  result.push_back(text.substr(pos + 1));
}

}